//
// Created by the DataSnap proxy generator.
// 9/26/2010 1:29:20 PM
//

unit ClientProxy;

interface

uses DBXCommon, DBXClient, DBXJSON, DSProxy, Classes, SysUtils, DB, SqlExpr, DBXDBReaders, Employee, DBXJSONReflect;

type
  TServerMethods1Client = class(TDSAdminClient)
  private
    FEchoStringCommand: TDBXCommand;
    FReverseStringCommand: TDBXCommand;
    FReturnArrayCommand: TDBXCommand;
    FGetEmployeeCommand: TDBXCommand;
  public
    constructor Create(ADBXConnection: TDBXConnection); overload;
    constructor Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    function EchoString(Value: string): string;
    function ReverseString(Value: string): string;
    function ReturnArray(nSize: Integer): TJSONValue;
    function GetEmployee(id: Integer): TEmployee;
  end;

implementation

function TServerMethods1Client.EchoString(Value: string): string;
begin
  if FEchoStringCommand = nil then
  begin
    FEchoStringCommand := FDBXConnection.CreateCommand;
    FEchoStringCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FEchoStringCommand.Text := 'TServerMethods1.EchoString';
    FEchoStringCommand.Prepare;
  end;
  FEchoStringCommand.Parameters[0].Value.SetWideString(Value);
  FEchoStringCommand.ExecuteUpdate;
  Result := FEchoStringCommand.Parameters[1].Value.GetWideString;
end;

function TServerMethods1Client.ReverseString(Value: string): string;
begin
  if FReverseStringCommand = nil then
  begin
    FReverseStringCommand := FDBXConnection.CreateCommand;
    FReverseStringCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FReverseStringCommand.Text := 'TServerMethods1.ReverseString';
    FReverseStringCommand.Prepare;
  end;
  FReverseStringCommand.Parameters[0].Value.SetWideString(Value);
  FReverseStringCommand.ExecuteUpdate;
  Result := FReverseStringCommand.Parameters[1].Value.GetWideString;
end;

function TServerMethods1Client.ReturnArray(nSize: Integer): TJSONValue;
begin
  if FReturnArrayCommand = nil then
  begin
    FReturnArrayCommand := FDBXConnection.CreateCommand;
    FReturnArrayCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FReturnArrayCommand.Text := 'TServerMethods1.ReturnArray';
    FReturnArrayCommand.Prepare;
  end;
  FReturnArrayCommand.Parameters[0].Value.SetInt32(nSize);
  FReturnArrayCommand.ExecuteUpdate;
  Result := TJSONValue(FReturnArrayCommand.Parameters[1].Value.GetJSONValue(FInstanceOwner));
end;

function TServerMethods1Client.GetEmployee(id: Integer): TEmployee;
begin
  if FGetEmployeeCommand = nil then
  begin
    FGetEmployeeCommand := FDBXConnection.CreateCommand;
    FGetEmployeeCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FGetEmployeeCommand.Text := 'TServerMethods1.GetEmployee';
    FGetEmployeeCommand.Prepare;
  end;
  FGetEmployeeCommand.Parameters[0].Value.SetInt32(id);
  FGetEmployeeCommand.ExecuteUpdate;
  if not FGetEmployeeCommand.Parameters[1].Value.IsNull then
  begin
    FUnMarshal := TDBXClientCommand(FGetEmployeeCommand.Parameters[1].ConnectionHandler).GetJSONUnMarshaler;
    try
      Result := TEmployee(FUnMarshal.UnMarshal(FGetEmployeeCommand.Parameters[1].Value.GetJSONValue(True)));
    finally
      FreeAndNil(FUnMarshal)
    end
  end
  else
    Result := nil;
end;


constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection);
begin
  inherited Create(ADBXConnection);
end;


constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean);
begin
  inherited Create(ADBXConnection, AInstanceOwner);
end;


destructor TServerMethods1Client.Destroy;
begin
  FreeAndNil(FEchoStringCommand);
  FreeAndNil(FReverseStringCommand);
  FreeAndNil(FReturnArrayCommand);
  FreeAndNil(FGetEmployeeCommand);
  inherited;
end;

end.

