unit Employee;

interface

uses
  SysUtils, DateUtils;

type
  TEmployee = class
  private
    FLastName: string;
    FHireDate: TDate;
    FSalary: Double;
    FFirstName: string;
    procedure SetFirstName(const Value: string);
    procedure SetHireDate(const Value: TDate);
    procedure SetLastName(const Value: string);
    procedure SetSalary(const Value: Double);
  public
    function ToString: string; override;
    property FirstName: string read FFirstName write SetFirstName;
    property LastName: string read FLastName write SetLastName;
    property HireDate: TDate read FHireDate write SetHireDate;
    property Salary: Double read FSalary write SetSalary;
  end;

implementation

{ TEmployee }

procedure TEmployee.SetFirstName(const Value: string);
begin
  FFirstName := Value;
end;

procedure TEmployee.SetHireDate(const Value: TDate);
begin
  FHireDate := Value;
end;

procedure TEmployee.SetLastName(const Value: string);
begin
  FLastName := Value;
end;

procedure TEmployee.SetSalary(const Value: Double);
begin
  FSalary := Value;
end;

function TEmployee.ToString: string;
begin
  Result := FirstName + ' ' + LastName +
    ' since ' + DateToStr(FHireDate);
end;

end.
