unit ServerMethodsUnit1;

interface

uses
  SysUtils, Classes, DSServer, DBXFirebird, FMTBcd, Provider, DB,
  SqlExpr, DBXJson, Employee;

type
  TServerMethods1 = class(TDSServerModule)
    FBCONNECTION: TSQLConnection;
    EMPLOYEE: TSQLDataSet;
    DataSetProviderEmployee: TDataSetProvider;
  private
    { Private declarations }
  public
    { Public declarations }
    function EchoString(Value: string): string;
    function ReverseString(Value: string): string;
    function ReturnArray (nSize: Integer): TJSONValue;
    function GetEmployee (id: Integer): TEmployee;
  end;

implementation

{$R *.dfm}

uses StrUtils;

function TServerMethods1.EchoString(Value: string): string;
begin
  Result := Value;
end;

function TServerMethods1.GetEmployee(id: Integer): TEmployee;
begin
  // looks for employee ID (returns fixed data for now)
  Result := TEmployee.Create;
  Result.FirstName := 'Mitch';
  Result.LastName := 'Brown';
  Result.HireDate := Date;
  Result.Salary := 100000;
end;

function TServerMethods1.ReturnArray(nSize: Integer): TJSONValue;
var
  i: Integer;
  jArray: TJSOnArray;
begin
  jArray := TJSONArray.Create;
  for i := 1 to nSize do
    jArray.Add('Element ' + IntToStr (i));
  Result := jArray;
end;

function TServerMethods1.ReverseString(Value: string): string;
begin
  Result := StrUtils.ReverseString(Value);
end;

end.

